package ex.be;

import blang.core.DeboxedName;
import blang.core.IntVar;
import blang.core.Model;
import blang.core.ModelBuilder;
import blang.core.ModelComponent;
import blang.core.RealVar;
import blang.inits.Arg;
import blang.inits.DesignatedConstructor;
import blang.types.StaticUtils;
import blang.types.internals.IntScalar;
import blang.types.internals.RealScalar;
import ca.ubc.stat.blang.StaticJavaUtils;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Optional;
import java.util.function.Supplier;

@SuppressWarnings("all")
public class LaunchPrediction implements Model {
  public static class Builder implements ModelBuilder {
    private boolean fromCommandLine = false;
    
    @Arg
    public Optional<RealVar> failureProbability;
    
    public LaunchPrediction.Builder setFailureProbability(final RealVar failureProbability) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.failureProbability = Optional.of(failureProbability);
      return this;
    }
    
    @Arg
    public Optional<IntVar> launch1;
    
    public LaunchPrediction.Builder setLaunch1(final IntVar launch1) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.launch1 = Optional.of(launch1);
      return this;
    }
    
    @Arg
    public Optional<IntVar> launch2;
    
    public LaunchPrediction.Builder setLaunch2(final IntVar launch2) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.launch2 = Optional.of(launch2);
      return this;
    }
    
    @Arg
    public Optional<IntVar> launch3;
    
    public LaunchPrediction.Builder setLaunch3(final IntVar launch3) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.launch3 = Optional.of(launch3);
      return this;
    }
    
    @Arg
    public Optional<IntVar> nextLaunch;
    
    public LaunchPrediction.Builder setNextLaunch(final IntVar nextLaunch) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.nextLaunch = Optional.of(nextLaunch);
      return this;
    }
    
    public LaunchPrediction build() {
      // For each optional type, either get the value, or evaluate the ?: expression
      RealVar failureProbability;
      if (this.failureProbability != null && this.failureProbability.isPresent()) {
        failureProbability = this.failureProbability.get();
      } else {
        failureProbability = $generated__11();
      }
      final RealVar __failureProbability = failureProbability;
      IntVar launch1;
      if (this.launch1 != null && this.launch1.isPresent()) {
        launch1 = this.launch1.get();
      } else {
        launch1 = $generated__12(failureProbability);
      }
      final IntVar __launch1 = launch1;
      IntVar launch2;
      if (this.launch2 != null && this.launch2.isPresent()) {
        launch2 = this.launch2.get();
      } else {
        launch2 = $generated__13(failureProbability, launch1);
      }
      final IntVar __launch2 = launch2;
      IntVar launch3;
      if (this.launch3 != null && this.launch3.isPresent()) {
        launch3 = this.launch3.get();
      } else {
        launch3 = $generated__14(failureProbability, launch1, launch2);
      }
      final IntVar __launch3 = launch3;
      IntVar nextLaunch;
      if (this.nextLaunch != null && this.nextLaunch.isPresent()) {
        nextLaunch = this.nextLaunch.get();
      } else {
        nextLaunch = $generated__15(failureProbability, launch1, launch2, launch3);
      }
      final IntVar __nextLaunch = nextLaunch;
      // Build the instance after boxing params
      return new LaunchPrediction(
        __failureProbability, 
        __launch1, 
        __launch2, 
        __launch3, 
        __nextLaunch
      );
    }
  }
  
  @DesignatedConstructor
  public static LaunchPrediction.Builder builderFromCommandLine() {
    Builder result = new Builder();
    result.fromCommandLine = true;
    return result;
  }
  
  private final RealVar failureProbability;
  
  public RealVar getFailureProbability() {
    return failureProbability;
  }
  
  private final IntVar launch1;
  
  public IntVar getLaunch1() {
    return launch1;
  }
  
  private final IntVar launch2;
  
  public IntVar getLaunch2() {
    return launch2;
  }
  
  private final IntVar launch3;
  
  public IntVar getLaunch3() {
    return launch3;
  }
  
  private final IntVar nextLaunch;
  
  public IntVar getNextLaunch() {
    return nextLaunch;
  }
  
  /**
   * Utility main method for posterior inference on this model
   */
  public static void main(final String[] arguments) {
    StaticJavaUtils.callRunner(Builder.class, arguments);
  }
  
  /**
   * Auxiliary method generated to translate:
   * launch1
   */
  private static IntVar $generated__0(final RealVar failureProbability, final IntVar launch1, final IntVar launch2, final IntVar launch3, final IntVar nextLaunch) {
    return launch1;
  }
  
  /**
   * Auxiliary method generated to translate:
   * failureProbability
   */
  private static RealVar $generated__1(final RealVar failureProbability) {
    return failureProbability;
  }
  
  public static class $generated__1_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__1(failureProbability);
    }
    
    public String toString() {
      return "failureProbability";
    }
    
    private final RealVar failureProbability;
    
    public $generated__1_class(final RealVar failureProbability) {
      this.failureProbability = failureProbability;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * launch2
   */
  private static IntVar $generated__2(final RealVar failureProbability, final IntVar launch1, final IntVar launch2, final IntVar launch3, final IntVar nextLaunch) {
    return launch2;
  }
  
  /**
   * Auxiliary method generated to translate:
   * failureProbability
   */
  private static RealVar $generated__3(final RealVar failureProbability) {
    return failureProbability;
  }
  
  public static class $generated__3_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__3(failureProbability);
    }
    
    public String toString() {
      return "failureProbability";
    }
    
    private final RealVar failureProbability;
    
    public $generated__3_class(final RealVar failureProbability) {
      this.failureProbability = failureProbability;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * launch3
   */
  private static IntVar $generated__4(final RealVar failureProbability, final IntVar launch1, final IntVar launch2, final IntVar launch3, final IntVar nextLaunch) {
    return launch3;
  }
  
  /**
   * Auxiliary method generated to translate:
   * failureProbability
   */
  private static RealVar $generated__5(final RealVar failureProbability) {
    return failureProbability;
  }
  
  public static class $generated__5_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__5(failureProbability);
    }
    
    public String toString() {
      return "failureProbability";
    }
    
    private final RealVar failureProbability;
    
    public $generated__5_class(final RealVar failureProbability) {
      this.failureProbability = failureProbability;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * nextLaunch
   */
  private static IntVar $generated__6(final RealVar failureProbability, final IntVar launch1, final IntVar launch2, final IntVar launch3, final IntVar nextLaunch) {
    return nextLaunch;
  }
  
  /**
   * Auxiliary method generated to translate:
   * failureProbability
   */
  private static RealVar $generated__7(final RealVar failureProbability) {
    return failureProbability;
  }
  
  public static class $generated__7_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__7(failureProbability);
    }
    
    public String toString() {
      return "failureProbability";
    }
    
    private final RealVar failureProbability;
    
    public $generated__7_class(final RealVar failureProbability) {
      this.failureProbability = failureProbability;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * failureProbability
   */
  private static RealVar $generated__8(final RealVar failureProbability, final IntVar launch1, final IntVar launch2, final IntVar launch3, final IntVar nextLaunch) {
    return failureProbability;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0
   */
  private static RealVar $generated__9() {
    return new blang.core.RealConstant(0);
  }
  
  public static class $generated__9_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__9();
    }
    
    public String toString() {
      return "0";
    }
    
    public $generated__9_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * 1
   */
  private static RealVar $generated__10() {
    return new blang.core.RealConstant(1);
  }
  
  public static class $generated__10_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__10();
    }
    
    public String toString() {
      return "1";
    }
    
    public $generated__10_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__11() {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentInt
   */
  private static IntVar $generated__12(final RealVar failureProbability) {
    IntScalar _latentInt = StaticUtils.latentInt();
    return _latentInt;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentInt
   */
  private static IntVar $generated__13(final RealVar failureProbability, final IntVar launch1) {
    IntScalar _latentInt = StaticUtils.latentInt();
    return _latentInt;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentInt
   */
  private static IntVar $generated__14(final RealVar failureProbability, final IntVar launch1, final IntVar launch2) {
    IntScalar _latentInt = StaticUtils.latentInt();
    return _latentInt;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentInt
   */
  private static IntVar $generated__15(final RealVar failureProbability, final IntVar launch1, final IntVar launch2, final IntVar launch3) {
    IntScalar _latentInt = StaticUtils.latentInt();
    return _latentInt;
  }
  
  /**
   * Note: the generated code has the following properties used at runtime:
   *   - all arguments are annotated with a BlangVariable annotation
   *   - params additionally have a Param annotation
   *   - the order of the arguments is as follows:
   *     - first, all the random variables in the order they occur in the blang file
   *     - second, all the params in the order they occur in the blang file
   * 
   */
  public LaunchPrediction(@DeboxedName("failureProbability") final RealVar failureProbability, @DeboxedName("launch1") final IntVar launch1, @DeboxedName("launch2") final IntVar launch2, @DeboxedName("launch3") final IntVar launch3, @DeboxedName("nextLaunch") final IntVar nextLaunch) {
    this.failureProbability = failureProbability;
    this.launch1 = launch1;
    this.launch2 = launch2;
    this.launch3 = launch3;
    this.nextLaunch = nextLaunch;
  }
  
  /**
   * A component can be either a distribution, support constraint, or another model  
   * which recursively defines additional components.
   */
  public Collection<ModelComponent> components() {
    ArrayList<ModelComponent> components = new ArrayList();
    
    { // Code generated by: launch1 | failureProbability ~ Bernoulli(failureProbability)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Bernoulli(
          $generated__0(failureProbability, launch1, launch2, launch3, nextLaunch), 
          new $generated__1_class(failureProbability)
        )
        );
    }
    { // Code generated by: launch2 | failureProbability ~ Bernoulli(failureProbability)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Bernoulli(
          $generated__2(failureProbability, launch1, launch2, launch3, nextLaunch), 
          new $generated__3_class(failureProbability)
        )
        );
    }
    { // Code generated by: launch3 | failureProbability ~ Bernoulli(failureProbability)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Bernoulli(
          $generated__4(failureProbability, launch1, launch2, launch3, nextLaunch), 
          new $generated__5_class(failureProbability)
        )
        );
    }
    { // Code generated by: nextLaunch | failureProbability ~ Bernoulli(failureProbability)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Bernoulli(
          $generated__6(failureProbability, launch1, launch2, launch3, nextLaunch), 
          new $generated__7_class(failureProbability)
        )
        );
    }
    { // Code generated by: failureProbability ~ ContinuousUniform(0, 1)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.ContinuousUniform(
          $generated__8(failureProbability, launch1, launch2, launch3, nextLaunch), 
          new $generated__9_class(), 
          new $generated__10_class()
        )
        );
    }
    
    return components;
  }
}
