require("ggplot2")
require("dplyr")

data <- read.csv("/Users/bouchard/w/blogobayes/www/ex/be/results/all/LaunchPrediction-2095125564/samples/launch3.csv")

# ggplot has bad default sizes for large facetting
verticalSize <- 2.0 *  1 
horizontalSize <- 4.0

n_samples <- max(data$sample)
cut_off <- n_samples * 0.5
data <- subset(data, sample > cut_off)

p <- ggplot(data, aes(x = sample, y = value)) +
  geom_step() + 
  theme_bw() + 
  xlab("MCMC iteration") +
  ylab("sample") +
  ggtitle("Trace plot for: launch3")
ggsave("/Users/bouchard/w/blogobayes/www/ex/be/results/all/LaunchPrediction-2095125564/tracePlots/launch3.pdf", limitsize = F, height = verticalSize, width = horizontalSize)
